<template>
  <el-tabs v-model="activeTab" class="member-message-tab w-full">
    <el-tab-pane
      v-for="(tab, index) in tabs"
      :key="`tab-${index}`"
      :name="tab"
      :label="$t(tab)"
      :disabled="isLoading"
      class="px-6 py-4"
    >
      <template #label>
        <div class="flex items-center px-2">
          {{ $t(tab) }}
          <MessagesMessageCount
            v-show="unreadInfo[EnumUnreadInfoMapper[tab]]"
            :count="unreadInfo[EnumUnreadInfoMapper[tab]]"
            :is-unread="tab === 'Unread'"
          />
        </div>
      </template>
      <div class="flex items-center justify-between mb-2">
        <span class="pl-4 pr-2"></span>
        <div class="flex gap-2 items-center">
          <el-button
            class="h-8 !p-2 message-batch-action-btn !text-xs"
            type="text"
            :disabled="!messages.length"
            :loading="isUpdatingStatus === 'MarkAllRead' || isLoading"
            @click="onMarkAllRead"
          >
            <div class="flex items-center">
              <IMessageOpen
                v-if="isUpdatingStatus !== 'MarkAllRead' && !isLoading"
                class="w-4 h-4 mr-1"
              />
              {{ $t("Marked all read") }}
            </div>
          </el-button>
          <div class="message-batch-action-divider ol-bg-dark-2"></div>
          <el-button
            class="h-8 !p-2 message-batch-action-btn delete-btn !text-xs"
            type="text"
            :disabled="!messages.length"
            :loading="isUpdatingStatus === 'DeleteAll' || isLoading"
            @click="onOpenDeleteConfirmation(true)"
          >
            <div class="flex items-center">
              <ITrash
                v-if="isUpdatingStatus !== 'DeleteAll' && !isLoading"
                class="w-4 h-4 mr-1"
              />
              {{ $t("Delete all") }}
            </div>
          </el-button>
        </div>
      </div>
      <el-scrollbar v-loading="isLoading" style="height: calc(100vh - 440px)">
        <div class="flex flex-col gap-4 w-full">
          <MessagesMessageItem
            v-for="message in messages"
            :key="`${message}`"
            :message="message"
            @click="onMessageClicked"
            @click:delete="onOpenDeleteConfirmation"
          >
          </MessagesMessageItem>
        </div>
        <div
          v-if="!messages.length"
          class="w-full relative h-full flex justify-center items-center"
        >
          <utils-not-found />
        </div>
      </el-scrollbar>
      <div class="flex items-center justify-between mt-4 min-h-[36px]">
        <p class="flex items-center">
          <ITimeOutline class="w-4 h-4 mr-1" />
          {{ $t("All_transactions_are_time_stamped_at_GMT-4") }}
        </p>
        <Pagination
          v-if="messages.length"
          v-model="pagination"
          class="message-pagination"
          @change="fetchMessages"
        ></Pagination>
      </div>
    </el-tab-pane>
  </el-tabs>
  <MessagesPreviewMessageDialog
    v-model="isShowPreviewMessageDialog"
    v-model:message="messageDetail"
    @click:delete="onOpenDeleteConfirmation(messageDetail)"
  />
  <MessagesDeleteDialog
    v-model="isShowDeleteDialog"
    :is-delete-all="!messageDetail"
    :is-loading="
      isLoading ||
      isUpdatingStatus === 'DeleteAll' ||
      isUpdatingStatus === 'SingleDelete'
    "
    @click:delete="onConfirmDelete"
  />
</template>

<script setup lang="ts">
import { useMessage } from "~~/composables/useMessage";
import { EnumUnreadInfoMapper } from "~~/models/enums/enumMessage";
import IMessageOpen from "~/assets/icons/message-open.svg?component";
import ITrash from "~/assets/icons/trash.svg?component";
import ITimeOutline from "~/assets/icons/time-outline.svg?component";
import { memberMessageStore } from "~~/store/member-message";
import EnumMutation from "~~/models/enums/enumMutation";

const {
  isUpdatingStatus,
  messageDetail,
  isShowDeleteDialog,
  isShowPreviewMessageDialog,
  pagination,
  isLoading,
  tabs,
  activeTab,
  messages,
  unreadInfo,
  fetchMessages,
  onMessageClicked,
  onOpenDeleteConfirmation,
  onMarkAllRead,
  onConfirmDelete,
} = useMessage();

watch(
  activeTab,
  () => {
    pagination.value.CurrentPage = 1;
    memberMessageStore.commit(EnumMutation.updateActiveTab, activeTab.value);
    fetchMessages();
  },
  {
    immediate: true,
  }
);

onMounted(() => {
  activeTab.value = "Unread";
});
</script>

<style lang="scss">
.member-message-tab {
  .el-tabs__item {
    padding: 0 12px;
  }

  .el-tabs__item.is-active {
    color: var(--primary);
  }
}

.message-pagination.el-pagination {
  --el-pagination-bg-color: transparent;
  --el-pagination-text-color: var(--text5);
  --el-pagination-hover-color: var(--primary);
  --el-pagination-button-color: var(--text5);

  & > .el-pager {
    li {
      border-radius: 4px;
      &.is-active {
        border: 2px solid var(--primary);
        box-sizing: border-box;
      }
    }
  }
  & > button {
    &,
    &:disabled {
      background-color: transparent;
      height: 32px;
      color: var(--text5);
    }
  }
}

.message-batch-action-btn.el-button {
  color: var(--primary);
  background: transparent;
  &.delete-btn {
    color: var(--failure);
  }
  &,
  svg {
    fill: currentColor !important;
    stroke: unset !important;
  }
}

.message-batch-action-divider {
  --bg-base-color: var(--border);
  --bg-opacity: 0.3;

  width: 1px;
  height: 16px;
}

.message-action-button.el-button {
  --bg-opacity: 0.15;
  --bg-base-color: var(--background5);

  height: 30px;
  border-radius: 8px;
  color: var(--text5) !important;
  background-color: transparent;
  background-image: unset;
  border: none;
}

[data-device="mobile"] {
  .message-batch-action-divider {
    display: none;
  }
}
</style>
